!!C2O2-Ar PES
!!Distances in Angstrom and energies in Hartrees

program testPES
  ! Test program
  use compDist_2CO2_Ar
  use testing_2CO2_Ar
  use loadData_2CO2_Ar
  use Overall_PES_2CO2_Ar
  use AnglesStructures, only: Angles
  use CentreToCentreTuple_Module, only: CentreToCentreTuple
  use compAngles_2CO2_Ar
  use RegionE_Extrapolate_Module
  use permutations, only: fixpermutations, swapCO2s
  implicit none
  
  double precision, dimension(15):: rab =[real(8)::&
       4.6250000000000000d0,        3.5370427686516126d0,        2.5172974743842516d0, &
       5.7425296631997762d0,        4.6250000000000000d0,        3.5370427686516126d0, &
       6.8752263486709060d0,        5.7425296631997762d0,        4.6250000000000000d0, &
       4.1380740915898739d0,        4.6250000000000000d0,        5.3257545280000134d0, &
       6.1686268634289032d0,        5.6644450301860996d0,        5.3689837120057744d0 ]
  integer scanSize
  double precision:: E

  call load_GP_Asymp_Data_2CO2_Ar
  call load_GP_Data_2CO2_Ar
  
  E= PES_2CO2_Ar( rab )
  
  do scanSize=11, 400
     print *,'============Scan size ',scanSize,' ============'
     call scanThroughPointsEnergyTest( scanSize )
     !call scanThroughPointsPermutationsTest( scanSize )
  end do
  
end program testPES

subroutine printPercentError( actual, expected,string)
  implicit none
  double precision, intent(in)::actual,expected
  character(len=6), intent(in)::string

  print *,string,actual,actual-expected, (actual-expected)/expected*100.d0

  return
end subroutine printPercentError
