module PES_GP_Module
  use GP_variables_2CO2_Ar ! data structure - all variables needed
   implicit none
  private

  public:: PES_GP


contains

      
function PES_GP(xStar)
  double precision, dimension(:) :: xStar
  double precision:: PES_GP
  integer i,j,k
  double precision kSqExpAllPerms, kSqExpJthPerm, kKernTotal
  
  
  !====REGION A====
  if( (xStar(5).GE.xStar(11) .AND. xStar(11).GE. xStar(14)) .OR.  &
       (xStar(5).GE.xStar(14) .AND. xStar(14).GE. xStar(11)) ) then
     kKernTotal=0
     do i=1,nTraining_A
        kSqExpAllPerms=0
        do j=1,nPerms
           kSqExpJthPerm=1        
           do k=1,nDim
              kSqExpJthPerm  =  kSqExpJthPerm * &
                   ( exp( - (xStar(k)-xTrainingPerm_A(k,j,i))**2 /2.d0/lScale_A(k)**2) )
           end do !Dimensions (k)
           kSqExpAllPerms = kSqExpAllPerms + kSqExpJthPerm
        end do !Permuations (j)
        kKernTotal = kKernTotal + alpha_A(i) * kSqExpAllPerms
     end do !Training points (i)
     
     PES_GP=kKernTotal * expVar_A
     return
  endif
  

  !====REGION D====
  if( (xStar(11).GE.xStar(5) .AND. xStar(5).GE. xStar(14)) .OR. &
       (xStar(14).GE.xStar(5) .AND. xStar(5).GE.xStar(11)) ) then
     kKernTotal=0
     do i=1,nTraining_B
        kSqExpAllPerms=0
        do j=1,nPerms
           kSqExpJthPerm=1        
           do k=1,nDim
              kSqExpJthPerm  =  kSqExpJthPerm * &
                   ( exp( - (xStar(k)-xTrainingPerm_B(k,j,i))**2 /2.d0/lScale_B(k)**2) )
           end do !Dimensions (k)
           kSqExpAllPerms = kSqExpAllPerms + kSqExpJthPerm
        end do !Permuations (j)
        kKernTotal = kKernTotal + alpha_B(i) * kSqExpAllPerms
     end do !Training points (i)
     
     PES_GP=kKernTotal * expVar_B
     !PES_GP=100;
     return;
  endif
  

  !====REGION E====
  if( xStar(11).GE.xStar(5) .AND. xStar(14).GE. xStar(5)) then
     kKernTotal=0
     do i=1,nTraining_C
        kSqExpAllPerms=0
        do j=1,nPerms
           kSqExpJthPerm=1        
           do k=1,nDim
              kSqExpJthPerm  =  kSqExpJthPerm * &
                   ( exp( - (xStar(k)-xTrainingPerm_C(k,j,i))**2 /2.d0/lScale_C(k)**2) )
           end do !Dimensions (k)
           kSqExpAllPerms = kSqExpAllPerms + kSqExpJthPerm
        end do !Permuations (j)
        kKernTotal = kKernTotal + alpha_C(i) * kSqExpAllPerms
     end do !Training points (i)
     
     PES_GP=kKernTotal * expVar_C
     !PES_GP=100;
     return;
  endif
  
  ! Not found a valid region so end the programme.
  print *,'****************** REGION ERROR *************************'
  print *, xStar(5), xStar(11), xStar(14)
  print *,1.d0/xStar
  STOP 100
end function PES_GP

end module PES_GP_Module
