module Assert_Module

  public assertEqual_double, assertLessThanOrEqual_double

contains
  
  subroutine assertEqual_double( actual, expected, tolerance, message)
    implicit none
    double precision, intent(in):: actual, expected, tolerance
    Character(len = *), intent(in):: message

#ifdef ASSERTS
    if(abs(actual - expected) > tolerance) then
       print *,'Failed assertion'
       print *, message
       print *,'Actual: ',actual
       print *,'Expected: ',expected
       STOP 100
    endif
#endif
  end subroutine assertEqual_double


  subroutine assertLessThanOrEqual_double( lower, higher, tolerance, message)
    implicit none
    double precision, intent(in):: lower, higher, tolerance
    Character(len = *), intent(in):: message

#ifdef ASSERTS
    if( lower-higher > tolerance ) then
       print *,'Failed assertion'
       print *, message
       print *,'Lower: ',lower
       print *,'Higher: ',higher
       STOP 100
    endif
#endif
  end subroutine assertLessThanOrEqual_double

  
end module Assert_Module
