module checkRegion_2CO2_Ar
  use GP_variables_2CO2_Ar, only: nDim,  distTol
  implicit none
  private

  !!====Public interface================================================
  public :: isRegionE, isRegionD, isRegionA
  !!====================================================================
  
contains
logical function isRegionE( rab )
  double precision, dimension(nDim), intent(in) :: rab
  isRegionE = .false.

  if (rab(11) - rab(14) <  distTol .AND. rab(14) - rab(5) <  distTol ) then
     isRegionE = .true.
  endif
end function isRegionE


logical function isRegionD( rab )
  double precision, dimension(nDim), intent(in) :: rab
  isRegionD = .false.

  if (rab(11) - rab(5) <  distTol .AND. rab(5) - rab(14) <  distTol ) then
     isRegionD = .true.
  endif
end function isRegionD


logical function isRegionA( rab )
  double precision, dimension(nDim), intent(in) :: rab
  isRegionA = .false.

  if (rab(5) - rab(11) <  distTol .AND. rab(11) - rab(14) <  distTol ) then
     isRegionA = .true.
  endif
end function isRegionA

end module checkRegion_2CO2_Ar
