module AnglesAndVectors
  Interface
     subroutine computeAngles(rab, cosBeta1,sinBeta1, cosAlpha1, sinAlpha1, cosTheta23, sinTheta23)
       implicit none
       double precision, dimension(:)::  rab
       double precision cosBeta1,sinBeta1, cosAlpha1, sinAlpha1, cosTheta23, sinTheta23
     end subroutine computeAngles

     double precision function sqLength( u,v)
       implicit none
       double precision u(3),v(3)
     end function sqLength

     double precision function dotProd( u,v)
       implicit none
       double precision u(3),v(3)
     end function dotProd
     
  end Interface 
end module AnglesAndVectors

subroutine computeAngles(rab, cosBeta1,sinBeta1, cosAlpha1, sinAlpha1, cosTheta23, sinTheta23)
  use PES_details
  implicit none
  double precision, dimension(:)::  rab
  double precision cosBeta1,sinBeta1, cosAlpha1, sinAlpha1, cosTheta23, sinTheta23
  
 
  !cosBeta1= (rab(2)**2 + lCO**2 - rab(1)**2)  /  lCO/2.0/rab(2)
  cosBeta1= (rab(2)**2 + lCO**2 - (min(rab(1),rab(3)))**2)  /  lCO/2.0/rab(2)

  sinBeta1=sqrt(abs(1.0- cosBeta1**2))
  
  cosTheta23 = (rab(2)**2  + rab(5)**2  -  rab(7)**2)/2.0/rab(2)/rab(5)
  sinTheta23 = sqrt( abs(1 - cosTheta23**2))

  !cosAlpha1 = (lCO*lCO  -  rab(4)**2 + rab(5)**2 - 2.0*lCO*rab(5)*cosBeta1*cosTheta23) &
  !     /sinBeta1/sinTheta23/2.0/lCO/rab(5);
  cosAlpha1 = max(-1.0,min(1.0,(lCO*lCO  -  min(rab(4),rab(6))**2 + rab(5)**2 - 2.0*lCO*rab(5)*cosBeta1*cosTheta23) &
       /sinBeta1/sinTheta23/2.0/lCO/rab(5)));
  sinAlpha1 = sqrt( abs(1.0- cosAlpha1**2))

end subroutine computeAngles


double precision function sqLength( u,v)
  implicit none
  double precision u(3),v(3)
  sqLength = (u(1)-v(1))**2 + (u(2)-v(2))**2 + (u(3)-v(3))**2
end function sqLength

double precision function dotProd( u,v)
  implicit none
  double precision u(3),v(3)
  dotProd = u(1)*v(1) + u(2)*v(2) + u(3)*v(3)
end function dotProd
