!!CO2-Ar PES
!!Distances in Angstrom and energies in Hartrees


  
module GP_variables
  !User constants
  !! ==== Low quality options ====
  !character (len=10) :: qualityString="lQ_" ! hQ or lQ for high/low quality
  !integer :: nTraining_A=1326    ! choose from: 1326 783 611 529
  !integer :: nTraining_B=1303    ! choose from 1303 776
  !integer :: nTraining_C=894    ! choose from 894, 3141 529

  !! ====High quality options ====
  character (len=10) :: qualityString="hQ_" ! hQ or lQ for high/low quality
  integer :: nTraining_A=786     ! choose from: 786, 300, 100
  integer :: nTraining_B=1069    ! choose from 1069, 800, 776, 300, 100,95
  integer :: nTraining_C=909     ! choose from 909, 806, 517, 300, 100

  
  !System constants
  integer :: nDim=7
  integer :: nPerms=4

  !global variables
  double precision, allocatable :: alpha_A (:), lScale_A(:), &
       xTraining_A(:,:), xTrainingPerm_A(:,:,:), &
       alpha_B (:), lScale_B(:), xTraining_B(:,:), xTrainingPerm_B(:,:,:), &
       alpha_C (:), lScale_C(:), xTraining_C(:,:), xTrainingPerm_C(:,:,:)
  double precision expVar_A,NuggVar_A, gpEmax_A, expVar_B,NuggVar_B, &
       gpEmax_B, expVar_C,NuggVar_C, gpEmax_C
  

end module GP_variables

module RegionA_Options
  double precision :: RShortMax=4.5, RMedMax=5.5, RLongMax=9.3, gammaMax=-4.5
  double precision :: DeltaX=-0.5
end module RegionA_Options

module RegionC_Options
  double precision :: RShortMax=4.5, RMedMax=5.5, RLongMax=8.5, gammaMax=-4.5
  double precision :: DeltaX=-0.1
end module RegionC_Options

module PES_details 
  double precision :: lCO = 1.1632
  double precision :: AngToBohr =  1.8897259885789
  double precision:: scaleFactor=1!000000
  
  interface PES_GP 
     function PES_GP(xStar) 
       implicit none 
       double precision:: PES_GP
       double precision, dimension(:) ::  xStar
     end function PES_GP
  end interface PES_GP 
  
end module PES_details

