module PES_overall
   interface PES
     function PES( rab )
       implicit none
       double precision  PES
       double precision, dimension(:) :: rab
       double precision, allocatable :: xStar(:)
     end function PES
  end interface PES
end module PES_overall

module extrapolationFunctions
  interface !extrapFunctions
     function RegionA_Extrapolate( rab )
       implicit none
       double precision RegionA_Extrapolate
       double precision, dimension(:) :: rab
     end function RegionA_Extrapolate
     
     function RegionB_Extrapolate( rab )
       implicit none
       double precision RegionB_Extrapolate
       double precision, dimension(:) :: rab
     end function RegionB_Extrapolate

     function RegionC_Extrapolate( rab )
       implicit none
       double precision RegionC_Extrapolate
       double precision, dimension(:) :: rab
     end function RegionC_Extrapolate
     
  end interface !extrapFunctions
end module extrapolationFunctions

module compDist
  interface computeDistances
     subroutine computeDistances(r12,r13,r23,alpha1,beta1, rab)
       implicit none
       double precision, dimension(:)::  rab
       double precision  r12,r13,r23, beta1, alpha1
     end subroutine computeDistances

     subroutine computeDistancesWithSlide(r12,r13,r23,alpha1,beta1,cosThetaTilde,deltaX, rab)
       implicit none
       double precision, dimension(:)::  rab
       double precision  r12,r13,r23, beta1, alpha1,cosThetaTilde, deltaX
     end subroutine computeDistancesWithSlide
    end interface computeDistances  
end module compDist

module deBug
  interface testPerms
     subroutine testPerms(rab)
       implicit none
       double precision, dimension(:)::  rab
     end subroutine testPerms
  end interface testPerms
end module deBug
     
