!!CO2-Ar PES
!!Distances in Angstrom and energies in Hartrees

program testPES
  ! Test program
  use PES_details
  use GP_variables
  use deBug
  use PES_overall
  implicit none
  double precision, allocatable:: xStar(:)
  double precision e
  
  allocate( xStar(nDim))

  
  xStar(1:7)=(/0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7/)
  !rab(1:7)=(/0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7/)
  !xStar(1:3)=(/0.2765329200000000153814028 ,0.2449013399999999951450746, &
  !     0.1726287499999999974775733/)

  xStar(1:7)=(/ 0.39397754,  0.30631981,  0.23851206,  0.40764103, &
       0.49981457,0.46154775,  0.32430259/)

  !xStar(1:7)=(/0.31794246,  0.31045449,  0.27151724,  0.25582994, &
  !     0.32923382, 0.41245699,  0.25741053/)
  xStar(1:7)=(/0.25420569,  0.23092614,  0.2010653 ,  0.34904946,  &
       0.33757964,        0.28809428,  0.19648508/)

  !xStar(1:7)=(/0.31794246,  0.31045449,  0.27151724,  0.25582994,&
  !     0.32923382, 0.41245699,  0.25741053/)

  xStar(1:7)=(/0.27250869,  0.26780695,  0.24164043,  0.25573734, &
       0.28126721, 0.28064084,  0.2855485 /)

  xStar(1:7)=(/0.28416566,  0.29984828,  0.28208725,  0.28552456, &
       0.34042739, 0.3604324 ,  0.33712396/)

  xStar(1:7)=(/ 1.77593549612039, 2.17831209267799, 3.00702656121192, &
       8.69684583918130, 9.55584270092654, 10.4737386056373, &
       9.33265176863221 /)

  xStar(1:7)=(/ 5.72644605510856  ,      6.56166134490939 ,       7.48496381210276, &
       3.72748753720896 ,       2.72015993137361 ,       1.90011716598026, &
       8.11475415702156/)
  
  call load_GP_Data
  e = PES( xStar )
  !e = PES_GP( xStar)
  write(6,*)e


  !call fixedAngleSlice
  
  !call EvsE
  !call randomPointTest
  !call fixedAngleSlice
  
end program testPES

subroutine testPerms(rab)
  use PES_details
  use GP_variables
  use PES_overall
  implicit none
  double precision, allocatable:: rabPerm(:)
  integer perm
  double precision, dimension(:) :: rab
  double precision, allocatable:: EPerm(:)
  double precision :: toll = 1e-10, toll2=2e-4
  allocate( rabPerm(nDim))
  allocate( EPerm(nPerms))

  !print *,
  !print *,'*********Perm 1 *********************'
  EPerm(1) = PES( rab)
  EPerm(2) = EPerm(1)
  EPerm(3) = EPerm(1)
  EPerm(4) = EPerm(1)

  !print *,
  !print *,'*********Perm 2 *********************'
  rabPerm(1) = rab(3)
  rabPerm(2) = rab(2)
  rabPerm(3) = rab(1)
  rabPerm(4) = rab(6)
  rabPerm(5) = rab(5)
  rabPerm(6) = rab(4)
  rabPerm(7) = rab(7)
  EPerm(2) =  PES( rabPerm)

  perm=2
  if( abs(EPerm(1)-EPerm(perm))>toll .and. abs((EPerm(1)-EPerm(perm))/EPerm(1))>toll2) then
     print *,'****************** PERMUTATION ERROR (Perm 2)*************************'
     print *,rab
     print *, EPerm(1), EPerm(perm), abs(EPerm(1)-EPerm(perm)) , abs((EPerm(1)-EPerm(perm))/EPerm(1))
     ERROR STOP
  endif

  !print *,
  !print *,'*********Perm 3 *********************'
  rabPerm(1) = rab(4)
  rabPerm(2) = rab(5)
  rabPerm(3) = rab(6)
  rabPerm(4) = rab(1)
  rabPerm(5) = rab(2)
  rabPerm(6) = rab(3)
  rabPerm(7) = rab(7)
  EPerm(3) =  PES( rabPerm)

  perm=3
  if( abs(EPerm(1)-EPerm(perm))>toll .and. abs((EPerm(1)-EPerm(perm))/EPerm(1))>toll2) then
     print *,'****************** PERMUTATION ERROR (Perm 3)*************************'
     print *,rab
     print *, EPerm(1), EPerm(perm), abs(EPerm(1)-EPerm(perm)) , abs((EPerm(1)-EPerm(perm))/EPerm(1))
     ERROR STOP
  endif
  !print *,
  !print *,'*********Perm 4 *********************'
  rabPerm(1) = rab(6)
  rabPerm(2) = rab(5)
  rabPerm(3) = rab(4)
  rabPerm(4) = rab(3)
  rabPerm(5) = rab(2)
  rabPerm(6) = rab(1)
  rabPerm(7) = rab(7)
  EPerm(4) =  PES( rabPerm)
  

  !print *, EPerm(1), EPerm(2), EPerm(3), EPerm(4), abs(EPerm(1)-EPerm(2)), abs(EPerm(1)-EPerm(3)), abs(EPerm(1)-EPerm(4))

  perm=4
  if( abs(EPerm(1)-EPerm(perm))>toll .and. abs((EPerm(1)-EPerm(perm))/EPerm(1))>toll2) then
     print *,'****************** PERMUTATION ERROR (Perm 4)*************************'
     print *,'Distances ',rab
     print *, EPerm(1), EPerm(perm), abs(EPerm(1)-EPerm(perm)) , abs((EPerm(1)-EPerm(perm))/EPerm(1))
     ERROR STOP
  endif

end subroutine testPerms
  
  

subroutine EvsE()
  use PES_details
  use GP_variables
  use PES_overall
  use deBug
  implicit none
  double precision, allocatable:: rab(:), xStar(:), dum(:)
  double precision:: NonAdd, funcVal, RMSE=0, mean=0
  integer:: i,j, count=0, nPoints

  allocate (rab(nDim), xStar(nDim), dum(nDim+5) )

  !====Read test data and compute error====
  open (unit = 7, file = "Dec17_CCSDT_rInv-10000.lhc")
  nPoints=10005

  !open (unit = 7, file = "sliceY4-0Bt0A0THat0_CCSDT_rInv-70.lhc ")
  !nPoints=71

  !open (unit = 7, file = "RegionA_April17_CCSDT_rInv-5000.lhc")
  !nPoints=5044


  !open (unit = 7, file = "RegionB_May17_CCSDT_rInv-5000.lhc")
  !nPoints=5015
  
  !open (unit = 7, file = "RegionC_June18_CCSDT_rInv-5000.lhc ")
  !nPoints=5056

  
  
  open (unit=15, file="PES_Err.dat ", status='replace')

  do i=1,nPoints !!10078
        read(7,*) dum
        
     do j=1,nDim
        xStar(j)=dum(j)
     end do
     NonAdd=dum(nDim+5)

     rab(:) = 1/xStar(:)
     funcVal = PES(rab)
#ifdef DEBUG
        call testPerms( rab)
#endif
     
     if( dum(nDim+1)<0.007 .AND. dum(nDim+2)<0.007 .AND. dum(nDim+3)<0.007 &
        ) then
        write(15,*), NonAdd, funcVal, NonAdd-funcVal
        RMSE = RMSE + (NonAdd-funcVal)**2
        mean = mean + (NonAdd)**2
        count = count +1
     endif
  enddo

  print *,Sqrt(RMSE/(1.0*count)), Sqrt(mean/(1.0*count)), Sqrt(RMSE/mean)*100, count
     
end subroutine EvsE

subroutine fixedAngleSlice()
  use PES_details
  use GP_variables
  use PES_overall
  use compDist
  use deBug
  implicit none
  double precision, allocatable:: rab(:), xStar(:)
  double precision e, cosTheta,x
  double precision r12,r13,r23,rin,alpha1,beta1,start,end
  integer i,itot, flag


  !Get command line arguments
  double precision:: cosAngle
  integer :: num_args, ix
  character(len=40), dimension(:), allocatable :: args
  character(len=200) :: filename, extension
  
  num_args = command_argument_count()
  allocate(args(num_args))  ! I've omitted checking the return status of the allocation 

  do ix = 1, num_args
     call get_command_argument(ix,args(ix))
     ! now parse the argument as you wish
  end do

  if(num_args==0) then
     print *,'[Usage] CO2-2Ar_PES.out [r (smallest dist)] [cosThetaHat/Bar] [cosBeta] [cosAlpha1]', &
          '[0=region A/B; 1 region C] [filename]'
     return;
  endif
  
  read(args(1),*)rin
  read(args(2),*)cosTheta
  read(args(3),*)cosAngle
  beta1=acos(cosAngle)
  read(args(4),*)cosAngle
  alpha1=acos(cosAngle)
  read(args(5),*)flag

  
  PRINT*, rin, cosTheta,beta1,alpha1, flag


  allocate (rab(nDim), xStar(nDim) )

  extension = '.pes'
  filename = trim(args(6)) // trim(extension)

  
  itot=200

  start=2.0
  end =6.6
  end=25.0
  


  open (unit=15, file=filename, status='replace')
  if (flag<0.5) then
     r12=rin !set the smallest distance to rin (the command line argument)
     do i=0, itot
        
     ! specify centre-to-centre separation
        x = (  start + (end-start)*i/(1.0*itot) ) 
        r13=Sqrt( r12**2/4.0  +  x**2  -  r12*x*cosTheta )
        r23=Sqrt( r12**2/4.0  +  x**2  +  r12*x*cosTheta )
        
        call  computeDistances(r12,r13,r23,alpha1,beta1, rab)
        e=PES( rab)
#ifdef DEBUG
        call testPerms( rab)
#endif
        
        if( cosTheta>0.0) then
           write(15,*) 1.0/r13, abs( e)
        else
           write(15,*) 1.0/r23, abs( e)
        endif
        !print *,
        !print *,'========================================================================================================='
        !print *,
     enddo
  endif

  if (flag>0.5) then
     r23=rin !set the smallest distance to rin (the command line argument)
     do i=0, itot
        
     ! specify centre-to-centre separation
        x = (  start + (end-start)*i/(1.0*itot) ) 
        r12=Sqrt( r23**2/4.0  +  x**2  -  r23*x*cosTheta )
        r13=Sqrt( r23**2/4.0  +  x**2  +  r23*x*cosTheta )

        !print*,'X in slice subroutine ',x
        
        call  computeDistances(r12,r13,r23,alpha1,beta1, rab)
        e=PES( rab)
#ifdef DEBUG
        call testPerms( rab)
#endif
        write(15,*) 1.0/r12, abs( e)
        !print *,
        !print *,'========================================================================================================='
        !print *,
     enddo
  endif
  
  
  write(6,*)'Written to file: ',filename
  close(15)

end subroutine fixedAngleSlice

!   initialize a random seed from the system clock at every run (fortran 95 code)
subroutine init_random_seed()
  INTEGER :: i, n, clock
  INTEGER, DIMENSION(:), ALLOCATABLE :: seed
  CALL RANDOM_SEED(size = n)
  ALLOCATE(seed(n))
  CALL SYSTEM_CLOCK(COUNT=clock)
  seed = clock + 37 * (/ (i - 1, i = 1, n) /)
  CALL RANDOM_SEED(PUT = seed)
    DEALLOCATE(seed)
  end subroutine init_random_seed
  
subroutine randomPointTest()
  use PES_details
  use GP_variables
  use PES_overall
  use compDist
  use deBug
  implicit none
  double precision, allocatable:: rab(:), xStar(:)
  double precision e, cosTheta,x
  double precision:: r12,r13,r23,alpha1,beta1,start=1.0,end=30.0
  integer :: i,itot=50000000
  double precision:: cosAngle
  REAL :: rNum(5)

  allocate (rab(nDim), xStar(nDim) )

  CALL init_random_seed  
    
  do i=0, itot
     CALL RANDOM_NUMBER(rNum)
     r12 = 1.0 + 30.0*rNum(1)
     cosTheta = rNum(2)
     cosAngle = rNum(3)
     beta1=acos(cosAngle)
     cosAngle=rNum(4)
     alpha1=acos(cosAngle)
     x = start + (end-start)*rNum(5) 

     r13=Sqrt( r12**2/4.0  +  x**2  -  r12*x*cosTheta )
     r23=Sqrt( r12**2/4.0  +  x**2  +  r12*x*cosTheta )
     call  computeDistances(r12,r13,r23,alpha1,beta1, rab)
     !PRINT*, rab
     e=PES( rab)
#ifdef DEBUG
     call testPerms( rab)
#endif
     !PRINT*, r12, cosTheta,beta1,alpha1,x,' E=',e 
     
  enddo
  
end subroutine randomPointTest
  
  
  
subroutine computeDistances(r12,r13,r23,alpha1,beta1, rab)
  use PES_details
  use AnglesAndVectors
  implicit none
  double precision, dimension(:)::  rab
  double precision  r12,r13,r23, beta1, alpha1
  double precision O1(3),O2(3),C(3),Ar1(3),Ar2(3), cosTheta13

  C(:)=0.0
  O1(:)=0.0
  O2(:)=0.0
  Ar1(:)=0.0
  Ar2(:)=0.0

  !C is already at the origin
  O1(1)=lCO * sin( beta1) * cos(alpha1);
  O1(2)=lCO * sin( beta1) * sin(alpha1);
  O1(3)=lCO *cos(beta1);
  
  O2(1)=-lCO * sin( beta1)* cos(alpha1);
  O2(2)=-lCO * sin( beta1) * sin(alpha1);
  O2(3)=-lCO * cos(beta1);
  
  
  !Ar1
  Ar1(3)= r12;


  !Ar2
  cosTheta13 = (r12*r12 + r13*r13 - r23*r23) / 2.0/r12/r13;
  Ar2(1) = r13 * sqrt( abs(1.0 - cosTheta13*cosTheta13));
  Ar2(3) = r13 * cosTheta13;
    
  !print*,'*********************',Ar2, cosTheta13,sqrt( abs(1.0 - cosTheta13*cosTheta13))

  !compute interatomic distances
  rab(1) = sqrt( sqLength(Ar1,O1)  );
  rab(2) = sqrt( sqLength(Ar1,C)  );
  rab(3) = sqrt(  sqLength(Ar1,O2)  );
  
  rab(4) = sqrt(  sqLength(Ar2,O1)  );
  rab(5) = sqrt(  sqLength(Ar2,C)  );
  rab(6) = sqrt(  sqLength(Ar2,O2)  );
  
  rab(7) = sqrt(  sqLength(Ar2,Ar1)  );
  
end subroutine computeDistances


subroutine computeDistancesWithSlide(r12,r13,r23,alpha1,beta1,cosThetaTilde,deltaX, rab)
  use PES_details
  use AnglesAndVectors
  implicit none
  double precision, dimension(:)::  rab
  double precision  r12,r13,r23, beta1, alpha1,cosThetaTilde, deltaX
  double precision O1(3),O2(3),C(3),Ar1(3),Ar2(3), cosTheta13

  C(:)=0.0
  O1(:)=0.0
  O2(:)=0.0
  Ar1(:)=0.0
  Ar2(:)=0.0

  !C begin at the origin but slides along ThetaTilde a distance deltaX
  C(1)=deltaX*Sqrt(1.0- cosThetaTilde**2)
  C(3)=deltaX*cosThetaTilde
  
  
  O1(1)=C(1) + lCO * sin( beta1) * cos(alpha1);
  O1(2)=lCO * sin( beta1) * sin(alpha1);
  O1(3)=C(3) + lCO *cos(beta1);
  
  O2(1)=C(1) -lCO * sin( beta1)* cos(alpha1);
  O2(2)=-lCO * sin( beta1) * sin(alpha1);
  O2(3)=C(3) -lCO * cos(beta1);
  
  
  !Ar1
  Ar1(3)= r12;


  !Ar2
  cosTheta13 = (r12*r12 + r13*r13 - r23*r23) / 2.0/r12/r13;
  Ar2(1) = r13 * sqrt( abs(1.0 - cosTheta13*cosTheta13));
  Ar2(3) = r13 * cosTheta13;
    
  !print*,'*********************',Ar2, cosTheta13

  !compute interatomic distances
  rab(1) = sqrt( sqLength(Ar1,O1)  );
  rab(2) = sqrt( sqLength(Ar1,C)  );
  rab(3) = sqrt(  sqLength(Ar1,O2)  );
  
  rab(4) = sqrt(  sqLength(Ar2,O1)  );
  rab(5) = sqrt(  sqLength(Ar2,C)  );
  rab(6) = sqrt(  sqLength(Ar2,O2)  );
  
  rab(7) = sqrt(  sqLength(Ar2,Ar1)  );
  
end subroutine computeDistancesWithSlide





double precision function asymp(rab)
  use PES_details
  implicit none
  double precision rab(3)
  double precision c1,c2,c3, cAr, o1Ar, o2Ar

  c1= (  rab(1)**2 + lCO**2 - rab(2)**2)/2.0/rab(1)/lCO
  
  c2= (  rab(2)**2 + lCO**2 - rab(1)**2)/2.0/rab(2)/lCO
  c3= (  rab(3)**2 + lCO**2 - rab(1)**2)/2.0/rab(3)/lCO


  cAr  = - ( 4.64 * (1 + 3*c1**2)  +  3.30 * (5 - 3*c1**2) ) / (rab(1)*AngToBohr)**6
  o1Ar = - ( 8.69 * (1 + 3*c2**2)  +  4.76 * (5 - 3*c2**2) ) / (rab(2)*AngToBohr)**6
  o2Ar = - ( 8.69 * (1 + 3*c3**2)  +  4.76 * (5 - 3*c3**2) ) / (rab(3)*AngToBohr)**6
  
  asymp= cAr + o1Ar + o2Ar
end function asymp


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!Gaussian Process Code!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!pom


  
subroutine load_GP_Data
  use GP_variables
  use PES_details
  implicit none
  
  double precision, allocatable::  xStar(:)
  integer i,j,k
  double precision :: dum
  character (len=90) :: filename
  integer, allocatable:: perm(:,:)

  allocate (alpha_A(nTraining_A), lScale_A(nDim), xTraining_A(nDim,nTraining_A) &
       ,xTrainingPerm_A(nDim,nPerms,nTraining_A), xStar(nDim),    perm(nDim,nPerms))
   allocate (alpha_B(nTraining_B), lScale_B(nDim), xTraining_B(nDim,nTraining_B) &
        ,xTrainingPerm_B(nDim,nPerms,nTraining_B))
   allocate (alpha_C(nTraining_C), lScale_C(nDim), xTraining_C(nDim,nTraining_C) &
       ,xTrainingPerm_C(nDim,nPerms,nTraining_C))

  !====Load hyperparameters====
  if(nTraining_A<1000) then
     write (filename, '( "TrainingData/",A3,"RegionA_HyperParams_Symm", I3.3, ".dat" )' )  qualityString, nTraining_A
  else
     write (filename, '( "TrainingData/",A3,"RegionA_HyperParams_Symm", I4.4, ".dat" )' )  qualityString,nTraining_A
  endif
  open (unit = 7, file = filename)
  do i=1,nDim
     read (7,*) dum
     j=int(dum)
     !print *,i,j
     read (7,*) lScale_A(j)
  end do
  read (7,*) expVar_A
  read (7,*) NuggVar_A
  read (7,*) gpEMax_A
  close(7)
  
  if(nTraining_B<1000) then
     write (filename, '( "TrainingData/",A3,"RegionB_HyperParams_Symm", I3.3, ".dat" )' ) qualityString, nTraining_B
  else
     write (filename, '( "TrainingData/",A3,"RegionB_HyperParams_Symm", I4.4, ".dat" )' ) qualityString, nTraining_B
  endif
  open (unit = 7, file = filename)
  do i=1,nDim
     read (7,*) dum
     j=int(dum)
     !print *,i,j
     read (7,*) lScale_B(j)
  end do
  read (7,*) expVar_B
  read (7,*) NuggVar_B
  read (7,*) gpEMax_B
  close(7)


  if(nTraining_C<1000) then
     write (filename, '( "TrainingData/",A3,"RegionC_HyperParams_Symm", I3.3, ".dat" )' ) qualityString, nTraining_C
  else
     write (filename, '( "TrainingData/",A3,"RegionC_HyperParams_Symm", I4.4, ".dat" )' )  qualityString, nTraining_C
  endif
  open (unit = 7, file = filename)
  do i=1,nDim
     read (7,*) dum
     j=int(dum)
     !print *,i,j
     read (7,*) lScale_C(j)
  end do
  read (7,*) expVar_C
  read (7,*) NuggVar_C
  read (7,*) gpEMax_C
  close(7)
  
  
  !do i=1,nDim
  !   print *,i,lScale_A(i)
  !end do
  !print *,"HyperParams",expVar_A,NuggVar_A, gpEmax

  
  !====Load alpha coefficients====
  if(nTraining_A<1000) then
     write (filename, '( "TrainingData/",A3,"RegionA_alpha_Symm", I3.3, ".dat" )' ) qualityString, nTraining_A
  else
     write (filename, '( "TrainingData/",A3,"RegionA_alpha_Symm", I4.4, ".dat" )' )  qualityString,nTraining_A
  endif
  open (unit = 7, file = filename)
  do i=1,nTraining_A
     read (7,*) alpha_A(i)
     !print *,"alpha_A ",i, alpha_A(i)
  end do
  close(7)
  
  if(nTraining_B<1000) then
     write (filename, '( "TrainingData/",A3,"RegionB_alpha_Symm", I3.3, ".dat" )' ) qualityString, nTraining_B
  else
     write (filename, '( "TrainingData/",A3,"RegionB_alpha_Symm", I4.4, ".dat" )' ) qualityString, nTraining_B
  endif
  open (unit = 7, file = filename)
  do i=1,nTraining_B
     read (7,*) alpha_B(i)
     !print *,"alpha_B ",i, alpha_B(i)
  end do
  close(7)

  if(nTraining_C<1000) then
     write (filename, '( "TrainingData/",A3,"RegionC_alpha_Symm", I3.3, ".dat" )' ) qualityString, nTraining_C
  else
     write (filename, '( "TrainingData/",A3,"RegionC_alpha_Symm", I4.4, ".dat" )' )  qualityString,nTraining_C
  endif
  open (unit = 7, file = filename)
  do i=1,nTraining_C
     read (7,*) alpha_C(i)
     !print *,"alpha_C ",i, alpha_C(i)
  end do
  close(7)



  !====Load training data x values ====
  if(nTraining_A<1000) then
     write (filename, '( "TrainingData/",A3,"RegionA_xTraining", I3.3, ".dat" )' ) qualityString, nTraining_A
  else
     write (filename, '( "TrainingData/",A3,"RegionA_xTraining", I4.4, ".dat" )' ) qualityString, nTraining_A
  endif
  open (unit = 7, file = filename)
    
  do i=1,nTraining_A
     read (7,*) xTraining_A(:,i)
     !print *, xTraining(:,i)
  end do
  close(7)

  if(nTraining_B<1000) then
     write (filename, '( "TrainingData/",A3,"RegionB_xTraining", I3.3, ".dat" )' ) qualityString, nTraining_B
  else
     write (filename, '( "TrainingData/",A3,"RegionB_xTraining", I4.4, ".dat" )' ) qualityString, nTraining_B
  endif
  open (unit = 7, file = filename)
    
  do i=1,nTraining_B
     read (7,*) xTraining_B(:,i)
     !print *, xTraining(:,i)
  end do
  close(7)

  if(nTraining_C<1000) then
     write (filename, '( "TrainingData/",A3,"RegionC_xTraining", I3.3, ".dat" )' )  qualityString,nTraining_C
  else
     write (filename, '( "TrainingData/",A3,"RegionC_xTraining", I4.4, ".dat" )' ) qualityString, nTraining_C
  endif
  open (unit = 7, file = filename)
    
  do i=1,nTraining_C
     read (7,*) xTraining_C(:,i)
     !print *, xTraining(:,i)
  end do
  close(7)

  
  !====Load the permuations====
  write (filename, '( "CO2-2Ar.sym" )' )
  open (unit = 7, file = filename)
  read(7,*) perm

  !do i=1,nPerms
  !   do j=1,nDim
  !      write(6, fmt="(1x,a,i0)", advance="no") " ",perm(j,i)
  !   end do
  !   write(6,*)
  !end do

  ! ====Check that the lscales agree when there should be a permutation====
  do j=1,nDim
     do i=1,nPerms
        !print *, j, lScale_A(j), perm(j,i), lScale_A(perm(j,i)), lScale_A(j)-lScale_A(perm(j,i))
        if( (lScale_A(perm(j,i))-lScale_A(j))**2 > 1e-10 .OR. (lScale_B(perm(j,i))-lScale_B(j))**2  > 1e-10 &
           .OR. (lScale_C(perm(j,i))-lScale_C(j))**2 > 1e-10) then
           print *,"Length scales do not agree when the sym files says that they should"
           print *, j, lScale_A(j), perm(j,i), lScale_A(perm(j,i)), lScale_A(j)-lScale_A(perm(j,i))
           stop 9
        end if
     enddo
  enddo
  
  !! Permute the training vectors
  do i=1,nDim
     do j=1,nPerms
        do k=1,nTraining_A
           xTrainingPerm_A(i,j,k)=xTraining_A(perm(i,j),k)
        end do
        do k=1,nTraining_B
           xTrainingPerm_B(i,j,k)=xTraining_B(perm(i,j),k)
        end do
        do k=1,nTraining_C
           xTrainingPerm_C(i,j,k)=xTraining_C(perm(i,j),k)
        end do
     end do
  end do

end subroutine load_GP_Data
  
function PES_GP(xStar)
  use GP_variables
  use RegionA_Options
#ifdef DEBUG
  use RegionC_Options, ONLY: RLongMaxC => RLongMax, RMedMaxC => RMedMax, RShortMaxC => RShortMax
  use PES_details, only: scaleFactor
#endif

  implicit none
  double precision, dimension(:) :: xStar
  double precision:: PES_GP
  integer i,j,k
  double precision kSqExpAllPerms, kSqExpJthPerm, kKernTotal
  
  !====REGION A====
  if( xStar(2)>xStar(7) .AND. xStar(5)> xStar(7)) then
#ifdef DEBUG
     !print*,'PES: Region A'
     !print *, 1.0/max(xStar(1) ,xStar(2) ,xStar(3) ), RShortMax,'**************'
     !print *, 1.0/max(xStar(4) ,xStar(5) ,xStar(6) ), RMedMax,'**************'
     !print *, 1.0/xStar(7) , RLongMax,'**************'
     
     if( 1.0/max(xStar(1) ,xStar(2) ,xStar(3) ) > RShortMax *scaleFactor + 1e-6) then
        print *,'****************** REGION A ERROR *************************'
        ERROR STOP
     endif

     if( 1.0/max(xStar(4) ,xStar(5) ,xStar(6) ) > RMedMax *scaleFactor+ 1e-6) then
        print *,'****************** REGION A ERROR *************************'
        print *, 1.0/xStar(4) ,1.0/xStar(5) ,1.0/xStar(6), RLongMaxC
        ERROR STOP 
     endif

     if( 1.0/xStar(7) > RLongMax*scaleFactor + 1e-6) then
        print *,'****************** REGION A ERROR *************************'
        ERROR STOP
     endif     
#endif


     kKernTotal=0
     do i=1,nTraining_A
        kSqExpAllPerms=0
        do j=1,nPerms
           kSqExpJthPerm=1        
           do k=1,nDim
              kSqExpJthPerm  =  kSqExpJthPerm * &
                ( exp( - (xStar(k)-xTrainingPerm_A(k,j,i))**2 /2.0/lScale_A(k)**2) )
           end do !Dimensions (k)
           kSqExpAllPerms = kSqExpAllPerms + kSqExpJthPerm
        end do !Permuations (j)
        kKernTotal = kKernTotal + alpha_A(i) * kSqExpAllPerms
     end do !Training points (i)
     
     PES_GP=kKernTotal * expVar_A
     return
  endif


  !====REGION B====
  if( (xStar(2)>xStar(7) .AND. xStar(7)> xStar(5)) .OR. (xStar(5)>xStar(7) .AND. xStar(7)> xStar(2)) ) then
#ifdef DEBUG
     !print*,'PES: Region B'
     !print *, 1.0/max(xStar(1) ,xStar(2) ,xStar(3) ), RShortMax,'**************'
     !print *, 1.0/max(xStar(4) ,xStar(5) ,xStar(6) ), RLongMax,'**************'
     !print *, 1.0/xStar(7) , RMedMax,'**************'
     
     if( 1.0/max(xStar(1) ,xStar(2) ,xStar(3) ) > RShortMax *scaleFactor + 1e-6) then
        print *,'****************** REGION B ERROR *************************'
        ERROR STOP
     endif

     if( 1.0/max(xStar(4) ,xStar(5) ,xStar(6) ) > RLongMax *scaleFactor+ 1e-6) then
        print *,'****************** REGION B ERROR *************************'
        print *, 1.0/xStar(4) ,1.0/xStar(5) ,1.0/xStar(6), RLongMaxC
        ERROR STOP 
     endif

     if( 1.0/xStar(7) > RMedMax*scaleFactor + 1e-6) then
        print *,'****************** REGION B ERROR *************************'
        ERROR STOP
     endif     
#endif

     kKernTotal=0
     do i=1,nTraining_B
        kSqExpAllPerms=0
        do j=1,nPerms
           kSqExpJthPerm=1        
           do k=1,nDim
              kSqExpJthPerm  =  kSqExpJthPerm * &
                   ( exp( - (xStar(k)-xTrainingPerm_B(k,j,i))**2 /2.0/lScale_B(k)**2) )
           end do !Dimensions (k)
           kSqExpAllPerms = kSqExpAllPerms + kSqExpJthPerm
        end do !Permuations (j)
        kKernTotal = kKernTotal + alpha_B(i) * kSqExpAllPerms
     end do !Training points (i)
     
     PES_GP=kKernTotal * expVar_B
     return;
  endif


  !====REGION C====
  if( xStar(2)<xStar(7) .AND. xStar(5)< xStar(7)) then
     !print*,'PES: Region C'
#ifdef DEBUG
     !print *, 1.0/max(xStar(1) ,xStar(2) ,xStar(3) ), RMedMaxC,'**************'
     !print *, 1.0/max(xStar(4) ,xStar(5) ,xStar(6) ), RLongMaxC,'**************'
     !print *, 1.0/xStar(7) , RShortMaxC,'**************'
     
     if( 1.0/max(xStar(1) ,xStar(2) ,xStar(3) ) > RMedMaxC *scaleFactor + 1e-6) then
        print *,'****************** REGION C ERROR *************************'
        ERROR STOP
     endif

     if( 1.0/max(xStar(4) ,xStar(5) ,xStar(6) ) > RLongMaxC *scaleFactor+ 1e-6) then
        if( 1.0/max(xStar(4) ,xStar(5) ,xStar(6) ) > RLongMax *scaleFactor+ 1e-6) then
           print *,'****************** REGION C ERROR *************************'
           print *, 1.0/xStar(4) ,1.0/xStar(5) ,1.0/xStar(6), RLongMaxC
           ERROR STOP !! slight fudge since regions do not have the same geometric constraint values when they ought to.
        endif
     endif

     if( 1.0/xStar(7) > RShortMaxC*scaleFactor + 1e-6) then
        print *,'****************** REGION C ERROR *************************'
        ERROR STOP
     endif     
#endif
     
     kKernTotal=0
     do i=1,nTraining_C
        kSqExpAllPerms=0
        do j=1,nPerms
           kSqExpJthPerm=1        
           do k=1,nDim
              kSqExpJthPerm  =  kSqExpJthPerm * &
                   ( exp( - (xStar(k)-xTrainingPerm_C(k,j,i))**2 /2.0/lScale_C(k)**2) )
           end do !Dimensions (k)
           kSqExpAllPerms = kSqExpAllPerms + kSqExpJthPerm
        end do !Permuations (j)
        kKernTotal = kKernTotal + alpha_C(i) * kSqExpAllPerms
     end do !Training points (i)
     
     PES_GP=kKernTotal * expVar_C
     return;
  endif

  ! Not found a valid region so end the programme.
  print *,'****************** REGION ERROR *************************'
  ERROR STOP
end function PES_GP



function PES( rab )
  !! Takes in rab in Angstrom
  use PES_details
  use GP_variables
  use compDist
  use extrapolationFunctions
  use AnglesAndVectors
  implicit none
  double precision, dimension(:) :: rab
  double precision, allocatable :: xStar(:)! , rabnew(:),rabnewDelta(:)
  double precision  PES 
  allocate( xStar(nDim))!, rabnew(nDim),rabnewDelta(nDim))

  !============Perform the permutations========================
  if(rab(5)<rab(2)) then !We need to flip Ar1 and A2
     xStar(:) = rab(:) !Careful this is not the intended use of xStar!
     rab(1)=xStar(4)
     rab(2)=xStar(5)
     rab(3)=xStar(6)
     rab(4)=xStar(1)
     rab(5)=xStar(2)
     rab(6)=xStar(3)
     rab(7)=xStar(7)
  endif
  

  !============Compute using the GP or extrapolation method========================
  if( rab(2)<rab(5).AND.rab(5)<rab(7)) then !====CASE A====
     PES = RegionA_Extrapolate( rab)
     return
  endif

  if( rab(2)<rab(7).AND.rab(7)<rab(5)) then !====CASE B====
     PES = RegionB_Extrapolate( rab)
     return
  endif
  
  if( rab(7)<rab(2).AND.rab(7)<rab(5)) then !====CASE B====
     PES = RegionC_Extrapolate( rab)
     return
  endif
  
  ERROR STOP
  
end function PES

